/**
 * 
 */
var tapping=false;

Number.prototype.formatNumber=function(c,d,t){
    var n=this, 
    c=isNaN(c = Math.abs(c)) ? 2 : c, 
    d=d == undefined ? "." : d,
    t=t == undefined ? "," : t,
    s=n < 0 ? "-" : "",
    i=String(parseInt(n = Math.abs(Number(n) || 0).toFixed(c))), 
    j=(j = i.length) > 3 ? j % 3 : 0;
   return s + (j ? i.substr(0, j) + t : "") + i.substr(j).replace(/(\d{3})(?=\d)/g, "$1" + t) + (c ? d + Math.abs(n - i).toFixed(c).slice(2) : "");
 };
 

function initialise(){
	simulating=false;
	
	showAppTitle();
	showButtonCaptions();
	showProblem();
	defineConditionals();
	adjustCode();
	prepareAnswer();
	placeContents();
	$("#drawArea").hide();
	showSimulationValues(); //καλείται για να αποκρύψει όλα τα span elements
	initialiseEvents();
	showPrompt();
	setParameterValue(0,1);
	$(".varLabel").css("text-align","center");
}

function initialiseEvents(){
    
    $(".toChange").focus(function(){
        if(simulating){
            $("#"+this.id).blur();
        }
    });

    document.addEventListener("touchend",function(evt){
        if(tapping){
            tapping=false;
            $(".matched").removeClass("matched");
            evt.preventDefault();
            return;
        }
    });
    
	$("#clearBreakPoints").on("click touchend",function(){
	    $(".breakPointCmd").removeClass("breakPointCmd");
	});
	
	$(".algoCmd").on("click touchend",function(evt){
	    if(evt.target.id.substr(0,7)=="usrEntr") return;
		if($("#"+this.id).hasClass("breakPointCmd")){
			$("#"+this.id).removeClass("breakPointCmd");
		}
		else{
			$("#"+this.id).addClass("breakPointCmd");
		}
	});

	//touch events
	$("#showInfo").on("touchend",function(evt){
	    $("#showInfo").trigger("click");
	});
	
	//Κουμπιά διαχείρισης εφαρμογής
    $("#slideSpeed").bind("change keyup touchend",function(event,ui) {
        var maxSimSpeed=Number($(this).attr("max"))+1;
        simSpeed=maxSimSpeed-$(this).val();
    });
	
    $("#showCaptions").bind("change keyup touchend",function(event,ui) {
    	if($("#showCaptions:checked").val()=="show"){
    		buttonCaptionsVisible=true;
    	}
    	else{
    		buttonCaptionsVisible=false;
    	}
    	showButtonCaptions();
    });
    
    
    $("#showVarValues").bind("change keyup touchend",function(event,ui) {
    	if($("#showVarValues:checked").val()=="show"){
    		showVarValues=true;
    	}
    	else{
    		showVarValues=false;
    	}
    });
    
    $("#showComments").bind("change keyup touchend",function(event,ui) {
    	if($("#showComments:checked").val()=="show"){
    		$("#commentArea").slideDown("slow");
    		showComments=true;
    	}
    	else{
    		$("#commentArea").slideUp("slow");
    		showComments=false;
    	}
    });
	
    $("#requestConfirmations").bind("change keyup touchend",function(event,ui) {
    	if($("#requestConfirmations:checked").val()=="reqConfirm"){
    		requestConfirmationState=requestConfirmation;
    	}
    	else{
    		requestConfirmationState=dontRequestConfirmation;
    	}
    });
    
    $("#useMathematicalSymbols").bind("change keyup touchend",function(event,ui) {
    	if($("#useMathematicalSymbols:checked").val()=="useMath"){
    		requestConfirmationState=requestConfirmation;
    		slctdSymbols=symbolsMath;
    	}
    	else{
    		slctdSymbols=symbolsWords;
    	}
    	prepareAnswer();
    });
    
    $("#randomSelection").bind("change keyup touchend",function(event,ui) {
    	if($("#randomSelection:checked").val()=="rndSelection"){
    		selectRandomly=true;
    	}
    	else{
    		selectRandomly=false;
    	}
    });
    
    $("#showFullSimulationPath").bind("change keyup touchend",function(event,ui) {
    	if($("#showFullSimulationPath:checked").val()=="showFullSimPath"){
    		hideSimulationPath=false;
    	}
    	else{
    		hideSimulationPath=true;
    	}
    });

    $("#btnPlay").on("click touchstart",function(){
    	$("#showOptions").hide();
    	simulating=true;
    	$("#btnPlay").hide();
    	$("#btnStop").show();
    	$("#btnPause").prop("disabled",false);
    	$("#btnForward").prop("disabled",true);
		//resetSimulation(); //Η εντολή απενεργοποιείται για να είναι δυνατή η αυτόματη εκτέλεση από εκεί που σταμάτησε η βηματική
    	promptID=promptDuringRunning;
    	simulationAborted=false;
    	simulateCode(true);
    });
    
    $("#btnStop").on("click touchstart",function(){
        $("#drawArea").hide(animationRate);
    	simulating=false;
    	simulateCode(false);
    	resetSimulation();
    	$("#btnPlay").show();
    	$("#btnStop").hide();
    	$("#btnPause").show();
    	$("#btnContinue").hide();
    	$("#btnForward").show();
    	if(simulationAborted){
    	    promptID=promptToFillInBlanks;
    	}
    	else{
    	    promptID=promptToRunCode;
    	}
    	showPrompt();
    });
    
    $("#btnPause").on("click touchstart",function(){
    	$("#showOptions").show();
    	simulating=false;
    	$("#btnPause").hide();
    	$("#btnContinue").show();
    	clearInterval(timerLoop);
    	handleContinuationButtons();
    	showPrompt();
    });
    
    $("#btnContinue").on("click touchstart",function(){
    	$("#showOptions").hide();
    	simulating=true;
    	$("#btnContinue").hide();
    	$("#btnForward").prop("disabled",true);
    	$("#btnPause").show();
    	simulateCode(true);
    });
                
    $("#btnForward").on("click touchstart",function(){
        $("#drawArea").show(animationRate);
        simulationAborted=false;
    	if(simulationIndex==-1){
    		resetSimulation();
    	}
    	if(simulationIndex<=parseInt(endIf.substr(3,2))){
    		simulateRun();
    	}
    });
    
    $("#btnCheckCode").on("click touchstart",function(){
    	//checkCode();
    	checkSolution();
    	handleContinuationButtons();
    });

    $("#btnShowSolution").on("click touchstart",function(){
        if(promptID==promptOfficialSolutionVisible){
            alert("Η λύση φαίνεται ήδη!");
        }
        else{
            if(!requestConfirmationState || confirm("Θέλεις σίγουρα να αποκαλύψεις μία λύση;")){
                $("#btnCheckCode").prop("disabled",true);
                showSolution();
                promptID=promptOfficialSolutionVisible;
                showPrompt();
            }
        }
    });

    $("#btnNewProblem").on("click touchstart",function(){
    	$(".breakPointCmd").removeClass("breakPointCmd");
    	$(".hintedCommand").removeClass("hintedCommand");
    	$("#btnCheckCode").prop("disabled",false);
    	defineConditionals();
    	adjustCode();
    	simulating=false;
        simulateCode(false);
    	resetSimulation();
    	handleContinuationButtons();
    	prepareAnswer();
    	$("#btnStop").click();
        promptID=promptToFillInBlanks;
        showPrompt();
    });

    $("#btnEnter").on("click touchstart",function(){
		if(simulating)timerLoop=setInterval(function(){simulateRun();},simSpeed);
    });

    $("#number-A").on("touchstart",function(){
        $("#number-A").focus();
    });

    $("#number-A").bind("keyup mouseup",function(){
        var newValue=parseInt($("#number-A").val());
        if(newValue>=parseInt($("#number-A").attr("min")) && newValue<=parseInt($("#number-A").attr("max"))){
            setParameterValue(0,newValue);
        }
        else{
            setParameterValue(0,varValues[0]);
        }
        abortSimulation();
        resetSimulation();
        handleContinuationButtons();
    });

    $(".cellNavigation").mouseover(function(){
    	if($(this).css("opacity")>0){
      	  $("#"+this.id).fadeTo(0,1);
    	  $("#"+this.id).css({
    		  "background-color" : "#c0c0c0",
    		  "box-shadow" : "1px 1px 2px #000000,2px 2px 4px #505050,3px 3px 6px #a0a0a0"
    	  });
    	}
    });
    
    $(".cellNavigation").mouseout(function(){
    	if($(this).css("opacity")>0){
        	$(this).fadeTo(0,0.5);
        	$(this).css({
        		"background-color" : "#ffffff",
        		"box-shadow" : "1px 1px #ffffff,2px 2px #ffffff,3px 3px #ffffff"
        	});
    	}
    });
}

function setParameterValue(paramIndex,newValue){
	$("#number-"+String.fromCharCode(65+paramIndex)).val(newValue);
	varValues[paramIndex]=newValue;
	if(paramIndex==0){
	    xSim=newValue;
	    varValues[paramIndex]=xSim;
	}
}

function placeContents(){
	codeTopBorder=$("#buttonArea").outerHeight();
	drawTopBorder=codeTopBorder+$("#problemWording").outerHeight()+verticalBorder;
	commentTopBorder=commentTopBorder+$("#commentArea").outerHeight()+2*verticalBorder;
	
	$("#problemWording").css({left: horizontalBorder, top: codeTopBorder});
	var solutionTop=$("#problemWording").position().top+$("#problemWording").outerHeight()+verticalBorder;
	$("#solutionArea").css({left: horizontalBorder, top: solutionTop});
    //$("#solutionArea").width($("#problemWording").width());
    codeLeftBorder=Math.max($("#solutionArea").outerWidth(),$("#problemWording").outerWidth())+2*horizontalBorder;
    $("#problemWording").outerWidth($("#solutionArea").outerWidth());

	$("#algorithmStart").css({left: codeLeftBorder, top: codeTopBorder});
	$("#commentArea").css({left: codeLeftBorder, top: commentTopBorder, width: $("#algorithmStart").width(), height: 40});
	/*var drawAreaTop=$("#algorithmStart").position().top+$("#algorithmStart").outerHeight()+verticalBorder;
	var drawArealeft=$("#algorithmStart").position().left;
	$("#drawArea").css({left: drawArealeft, top: drawAreaTop});
    $("#drawArea").height($("#visualisation").height+2*verticalBorder);
    $("#drawArea").width($("#algorithmStart").width());*/
    //περιοχή ειδοποιήσεων
    promptTopBorder=$("#solutionArea").position().top+$("#solutionArea").outerHeight()+verticalBorder;
    $("#promptArea").css({top: promptTopBorder});
}

function adjustCode(){
	var j=-1;
	var html="<code class='algorithm'>";
	html+="\n<span class='algoCmd' id='cmd0'><span class='reservedWord'>ΔΙΑΒΑΣΕ</span> x</span>   <span class='showValues' id='xVal'></span>";
    j++;
    html+="\n<span class='algoCmd' id='cmd1'><span class='reservedWord'>ΑΝ</span> "+htmlFirstConditional+" <span class='reservedWord'>ΤΟΤΕ</span></span>   <span class='showValues' id='condition1'></span>";
    j++;
    html+="\n<span class='algoCmd' id='cmd2'>  <span class='reservedWord'>ΓΡΑΨΕ </span>1</span>   <span class='showValues' id='output1'></span>";
    j++;
    html+="\n<span class='algoCmd' id='cmd3'><span class='reservedWord'>ΑΛΛΙΩΣ_ΑΝ</span> "+htmlSecondConditional+" <span class='reservedWord'>ΤΟΤΕ</span></span>   <span class='showValues' id='condition2'></span>";
    j++;
    html+="\n<span class='algoCmd' id='cmd4'>  <span class='reservedWord'>ΓΡΑΨΕ </span>2</span>   <span class='showValues' id='output2'></span>";
    html+="\n<span class='algoCmd' id='cmd5'><span class='reservedWord'>ΑΛΛΙΩΣ</span></span>";
    j++;
    html+="\n<span class='algoCmd' id='cmd6'>  <span class='reservedWord'>ΓΡΑΨΕ </span>3</span>   <span class='showValues' id='output3'></span>";
    html+="\n<span class='algoCmd' id='cmd7'><span class='reservedWord'>ΤΕΛΟΣ_ΑΝ</span></span>";
    html+="</code>";
	$("#algorithmStart").html(html);
}

function prepareAnswer(){
    var msg="<code class='algorithm'><p>Το απόσπασμα εμφανίζει:</p>";
    msg+="1 <span id='entry1'>"+generateEntryPlaceholder("entry1",userEntry)+"</span><br>";
    msg+="2 <span id='entry2'>"+generateEntryPlaceholder("entry2",userEntry)+"</span><br>";
    msg+="3 <span id='entry3'>"+generateEntryPlaceholder("entry3",userEntry)+"</span></code>";
    $("#solutionArea").html(msg);
}

function showProblem(){
	$("#problemWording").css({left: 0, top: codeTopBorder});
	$("#problemWording").html(getProblemWording());
}

function getProblemWording(){
    var html="Μελετήστε προσεκτικά το διπλανό απόσπασμα αλγόριθμου, στο οποίο η μεταβλητή <span class='suggestedName'>x</span> δέχεται μόνο ακέραιες τιμές.<br>";
    html+="Για ποιες από αυτές το απόσπασμα θα εμφανίσει την τιμή 1,<br>για ποιες την τιμή 2<br>και για ποιές την τιμή 3;</p>";
	return html;
}

function showButtonCaptions(){
	if(buttonCaptionsVisible){
        $("#btnCheckCode").html("Υποβολή");
        $("#btnShowSolution").html("Λύση");
        $("#btnNewProblem").html("Νέο πρόβλημα");
        $("#btnPlay").html("Έναρξη");
        $("#btnStop").html("Αρχικοποίηση");
        $("#btnPause").html("Παύση");
        $("#btnContinue").html("Συνέχεια");
        $("#btnForward").html("Επόμενο");
        $("#btnOptions").html("Ρυθμίσεις");
        $(".btnMenu").css({"width":"175px"});
        $(".buttonData").width(160);
 	}
	else{
        $("#btnCheckCode").html("");
        $("#btnShowSolution").html("");
        $("#btnNewProblem").html("");
        $("#btnPlay").html("");
        $("#btnStop").html("");
        $("#btnPause").html("");
        $("#btnContinue").html("");
        $("#btnForward").html("");
        $("#btnOptions").html("");
        $(".btnMenu").css({"width":"30px"});
        $(".buttonData").width(40);
    }
}

function showPrompt(){
	var msg="";
    switch(promptID){
        case promptToFillInBlanks:
            msg="Χρησιμοποίησε τις πτυσσομενες λίστες για να συμπληρώσεις τα κενά.";
            msg+="<br>Η εκτέλεση του κώδικα ίσως σε διευκολύνει.";
            msg+="<br>Μέσω των ρυθμίσεων μπορείς να επιλέξεις μεταξύ λεκτικής και μαθηματικής διατύπωσης των ορίων.";
            msg+="<br>Το κουμπί Υποβολή σου επιτρέπει να ελέγξεις την απάντησή σου.";
            break;
        case promptToRunCode:
        case promptDuringRunning:
        case promptAtEndOfRun:
            break;
        case promptSubmittedSolution:
            if(errorsFound){
                msg="Η απάντησή σου δεν είναι σωστή.";
                msg+="<br>Μελέτησε προσεκτικότερα τις συνθήκες που αναγράφονται στη δομή πολλαπλής επιλογής, καθώς και τη σειρά με την οποία αυτές περνούν από έλεγχο.";
            }
            else{
                msg="Πράγματι βρήκες την απάντηση στο ερώτημα.";
                msg+="<br>Αν θέλεις μπορείς να εκτελέσεις το πρόγραμμα για να δοκιμάσεις τη λειτουργία του για διάφορες τιμές της μεταβλητής x.";
            }
            break;
        case promptOfficialSolutionVisible:
            msg="Αυτή που βλέπεις είναι η ορθή απάντηση στο ερώτημα.";
            msg+="<br>Αν θέλεις μπορείς να εκτελέσεις το πρόγραμμα για να δοκιμάσεις τη λειτουργία του για διάφορες τιμές της μεταβλητής x.";
        	break;
    }
    $("#prompt").html(msg);
}

function enableCodeSimulation(){
	$("#simulateControls").show(animationRate);
	$("#dataInput").show(animationRate);
}

function simulateCode(simulationSwitch){
	if(simulationSwitch){
		//έναρξη προσομοίωσης με κλήση timer
		timerLoop=setInterval(function(){simulateRun();},simSpeed);
	}
	else{
		clearInterval(timerLoop);
		simulating=false;
		$("#btnContinue").hide();
		$("#btnForward").hide();
    	$("#btnPlay").hide();
    	$("#btnPause").prop("disabled",true);
    	$("#btnStop").show();
    	$("#showOptions").show();
	}	
}

function simulateRun(){
	simulationIndex++;
	var nxtSimulationIndex=simulationIndex;
	var cmdSimulated="cmd"+simulationIndex;
	if($("#"+cmdSimulated).hasClass("breakPointCmd")){
		$("#btnPause").click();//Παύση σε breakpoint
	}
	handleContinuationButtons();
	
	if(hideSimulationPath){
	    $(".simulatingCode").removeClass("simulatingCode");
	}
	$("#cmd"+simulationIndex).addClass("simulatingCode");
	
	//Προσομοίωση αλγόριθμου
	switch(cmdSimulated){
	    case dataInput:
	        break;
        case ifStart:
            condition1Sim=stringLogicalValue(firstConditional,varNames,varValues,[],[]);
            if(condition1Sim=="error"){
                abortSimulation();
                return;
            }
            else{
                if(condition1Sim){
                   $("#"+ifStart).addClass("conditionTrue");
                }
                else{
                    $("#"+ifStart).addClass("conditionFalse");
                    nxtSimulationIndex=parseInt(output1.substr(3,2));
                }
            }
            break;
        case output1:
        	outputSim=1;
        	nxtSimulationIndex=parseInt(output3.substr(3,2));
            break;
        case ifElse:
            condition2Sim=stringLogicalValue(secondConditional,varNames,varValues,[],[]);
            if(condition2Sim=="error"){
                abortSimulation();
                return;
            }
            else{
                if(condition2Sim){
                   $("#"+ifElse).addClass("conditionTrue"); 
                }
                else{
                    $("#"+ifElse).addClass("conditionFalse");
                    nxtSimulationIndex=parseInt(output2.substr(3,2));
                }
            }
            break;
        case output2:
        	outputSim=2;
        	nxtSimulationIndex=parseInt(output3.substr(3,2));
            break;
        case Else:
        	$("#"+Else).addClass("conditionTrue");
            //μην κάνεις τίποτε
            break;
        case output3:
        	outputSim=3;
            break;
        case endIf:
            //μην κάνεις τίποτε
            break;
	}
	showSimulationValues();
	if(simulationIndex>parseInt(endIf.substr(3,2))){//Μετά την προσομοίωση της τελευταίας εντολής τερμάτισε το μηχανισμό προσομοίωσης
		simulateCode(false);
		promptID=promptAtEndOfRun;
	}
	simulationIndex=nxtSimulationIndex;
	showPrompt();
}

function handleContinuationButtons(){
	if(simulating)return;
	if(simulationIndex>parseInt(endIf.substr(3,2))){
		$("#btnForward").prop("disabled",true);
	}
	else{
		$("#btnForward").prop("disabled",false);
	}
}

function clearSimulated(){
	$(".simulatingCode").removeClass("simulatingCode");
	$(".conditionTrue").removeClass("conditionTrue");
	$(".conditionFalse").removeClass("conditionFalse");
	$(".conditionInError").removeClass("conditionInError");
}

function resetSimulation(){
	resetErrorMessages();
	clearSimulated();
	simulationIndex=-1;
	handleContinuationButtons();
	showSimulationValues();
	$("#commentArea").html("");
}

function generateEntryPlaceholder(entryID,presetValue){
	var newEntry=generateMenuEntry(entryID,primaryMenu)+"ˍˍˍ";
	return newEntry;
}

function generateMenuEntry(entryID,menuType){
    var menuEntry="<div tabindex='0' class='onclick-menu'>";
    menuEntry+="<ul class='onclick-menu-content'>";
    if(menuType!=secondaryMenu){
        menuEntry+="<li><button onclick='fillEntry(1,\""+entryID+"\","+menuType+")'>"+exprForNone[slctdSymbols]+"</button></li>";
        menuEntry+="<li><button onclick='fillEntry(2,\""+entryID+"\","+menuType+")'>"+exprForAll[slctdSymbols]+"</button></li>";
        menuEntry+="<li><button onclick='fillEntry(3,\""+entryID+"\","+menuType+")'>"+exprStart[slctdSymbols]+leftInfinityStart[slctdSymbols]+" ˍˍˍ "+leftInfinityEnd[slctdSymbols]+"</button></li>";
    }
    menuEntry+="<li><button onclick='fillEntry(4,\""+entryID+"\","+menuType+")'>"+exprStart[slctdSymbols]+leftLimit[slctdSymbols]+" ˍˍˍ "+rangeMiddle[slctdSymbols]+" ˍˍˍ "+rightLimit[slctdSymbols]+"</button></li>";
    menuEntry+="<li><button onclick='fillEntry(5,\""+entryID+"\","+menuType+")'>"+exprStart[slctdSymbols]+rightInfinityStart[slctdSymbols]+" ˍˍˍ "+rightInfinityEnd[slctdSymbols]+"</button></li>";
    menuEntry+="<li><button onclick='fillEntry(6,\""+entryID+"\","+menuType+")'>"+exprStart[slctdSymbols]+leftLimitForSingle[slctdSymbols]+" ˍˍˍ "+closingSet[slctdSymbols]+"</button></li>";
    menuEntry+="</ul>";
    menuEntry+="</div>";
    return menuEntry;
}

function fillEntry(entryType,entryID,menuType){
    var entry=document.getElementById(entryID);
    var column1=1;
    var column2=2;
    var entryText="";
    if(entryType==1){
        entryText="<span id='"+entryID+"_"+column1+"' data-info='κανένα x'>"+exprForNone[slctdSymbols]+"</span>";
    }
    else if(entryType==2){
        entryText="<span id='"+entryID+"_"+column1+"' data-info='κάθε x'>"+exprForAll[slctdSymbols]+"</span>";
    }
    else if(entryType==3){
        entryText=exprStart[slctdSymbols]+leftInfinityStart[slctdSymbols]+" <span class='toChange' id='"+entryID+"_"+column2+"' contenteditable='true'>ˍˍˍ</span> "+leftInfinityEnd[slctdSymbols];
        if(menuType==primaryMenu) entryText+=" "+exprSetUnionSymbol[slctdSymbols]+" "+generateMenuEntry(entryID+"b",secondaryMenu)+"<span id='"+entryID+"b'>ˍˍˍ</span>";
    }
    else if(entryType==4){
        entryText=exprStart[slctdSymbols]+leftLimit[slctdSymbols]+" <span class='toChange' id='"+entryID+"_"+column1+"' contenteditable='true'>ˍˍˍ</span>"+rangeMiddle[slctdSymbols]+"<span class='toChange' id='"+entryID+"_"+column2+"' contenteditable='true'>ˍˍˍ</span> "+rightLimit[slctdSymbols]+"</button></li>";
        if(menuType==primaryMenu) entryText+=" "+exprSetUnionSymbol[slctdSymbols]+" "+generateMenuEntry(entryID+"b",secondaryMenu)+"<span id='"+entryID+"b'>ˍˍˍ</span>";
    }
    else if(entryType==5){
        entryText=exprStart[slctdSymbols]+rightInfinityStart[slctdSymbols]+" <span class='toChange' id='"+entryID+"_"+column1+"' contenteditable='true'>ˍˍˍ</span>"+rightInfinityEnd[slctdSymbols]+"</button></li>";
    }
    else if(entryType==6){
        entryText=exprStart[slctdSymbols]+leftLimitForSingle[slctdSymbols]+" <span class='toChange' id='"+entryID+"_"+column1+"_EQ' contenteditable='true'>ˍˍˍ</span> "+closingSet[slctdSymbols]+"</button></li>";
    }
    
    var entryToShow="";
    if(menuType==primaryMenu){
        entryToShow=generateMenuEntry(entryID,primaryMenu)+entryText;
    	
    }
    else if(menuType==secondaryMenu){
    	entryToShow=entryText;
    }
    entry.innerHTML=entryToShow;
}

function showSimulationValues(){
	if(!showVarValues) return;
	
	//Είσοδος τιμής
	if(simulationIndex==parseInt(dataInput.substr(3,2))){
		$("#xVal").html(" x="+xSim+" ");
		$("#xVal").show(animationRate);
	}
	else{
		$("#xVal").html("");
		$("#xVal").hide(animationRate);
	}

	//Πρώτη συνθήκη του ΑΝ
	if(simulationIndex==parseInt(ifStart.substr(3,2))){
		$("#condition1").html(" Σ1="+greekLogicalResult(condition1Sim)+" ");
		$("#condition1").show(animationRate);
	}
	else{
		$("#condition1").html("");
		$("#condition1").hide(animationRate);
	}
	
	//Πρώτο τμήμα της ΑΝ
	if(simulationIndex==parseInt(output1.substr(3,2))){
		$("#output1").html(" Εμφάνιση της τιμής 1 ");
		$("#output1").show(animationRate);
	}
	else{
		$("#output1").html("");
		$("#output1").hide(animationRate);
	}

	//Συνθήκη του ΑΛΛΙΩΣ_ΑΝ
	if(simulationIndex==parseInt(ifElse.substr(3,2))){
		$("#condition2").html(" Σ2="+greekLogicalResult(condition2Sim)+" ");
		$("#condition2").show(animationRate);
	}
	else{
		$("#condition2").html("");
		$("#condition2").hide(animationRate);
	}

	//Δεύτερο τμήμα της ΑΝ
	if(simulationIndex==parseInt(output2.substr(3,2))){
		$("#output2").html(" Εμφάνιση της τιμής 2 ");
		$("#output2").show(animationRate);
	}
	else{
		$("#output2").html("");
		$("#output2").hide(animationRate);
	}

	//Τρίτο τμήμα της ΑΝ
	if(simulationIndex==parseInt(output3.substr(3,2))){
		$("#output3").html(" Εμφάνιση της τιμής 3 ");
		$("#output3").show(animationRate);
	}
	else{
		$("#output3").html("");
		$("#output3").hide(animationRate);
	}
}

function greekLogicalResult(originalVal){
    if(originalVal){
        return "ΑΛΗΘΗΣ";
    }
    else{
        return "ΨΕΥΔΗΣ";
    }
}

function abortSimulation(){
    simulationAborted=true;
	$("#btnStop").click();
}

function defineConditionals(){
	var operatorOR=" Ή ";
	var operatorAND=" ΚΑΙ ";
	var operatorNOT=" ΟΧΙ ";
	var htmlOperatorOR="<span class='reservedWord'> Ή </span>";
	var htmlOperatorAND="<span class='reservedWord'> ΚΑΙ </span>";
	var htmlOperatorNOT="<span class='reservedWord'> ΟΧΙ </span>";
	if(selectRandomly){
		problemVariation=parseInt(Math.random()*noOfProblems)+1;
		
	}
	else{
		problemVariation++;
		if(problemVariation>noOfProblems){
			problemVariation=1;
		}
	}
	if(debug) $("#debug").html(problemVariation);
	firstLimit=parseInt((Math.random()-0.3)*80);
	secondLimit=parseInt(Math.random()*49)+5+firstLimit;
	switch(problemVariation){
	case 1: //1:x>first, 2: κανένα, 3: x<=first
		firstConditional="x>"+firstLimit;
		secondConditional="x>"+secondLimit;
		htmlFirstConditional="x<span class='reservedWord'> > </span>"+firstLimit;
		htmlSecondConditional="x<span class='reservedWord'> > </span>"+secondLimit;
		break;
	case 2: //1:x>=first, 2: κανένα, 3: x<first
		firstConditional="x>="+firstLimit;
		secondConditional="x>"+secondLimit;
		htmlFirstConditional="x<span class='reservedWord'> >= </span>"+firstLimit;
		htmlSecondConditional="x<span class='reservedWord'> > </span>"+secondLimit;
		break;
	case 3: //1:x>first, 2: κανένα, 3: x<=first
	    ffirstConditional="x>"+firstLimit;
	    secondConditional="x>="+secondLimit;
        htmlFfirstConditional="x<span class='reservedWord'> > </span>"+firstLimit;
        htmlSecondConditional="x<span class='reservedWord'> >= </span>"+secondLimit;
		break;
	case 4: //1:x>=first, 2: κανένα, 3: x<first
		firstConditional="x>="+firstLimit;
		secondConditional="x>="+secondLimit;
		htmlFirstConditional="x<span class='reservedWord'> >= </span>"+firstLimit;
		htmlSecondConditional="x<span class='reservedWord'> >= </span>"+secondLimit;
		break;
	case 5: //1:x<first, 2: first<=x<second, 3: x>=second
		firstConditional="x<"+firstLimit;
		secondConditional="x<"+secondLimit;
		htmlFirstConditional="x<span class='reservedWord'> < </span>"+firstLimit;
		htmlSecondConditional="x<span class='reservedWord'> < </span>"+secondLimit;
		break;
	case 6: //1:x<=first, 2: first<x<second, 3: x>=second
		firstConditional="x<="+firstLimit;
		secondConditional="x<"+secondLimit;
		htmlFirstConditional="x<span class='reservedWord'> <= </span>"+firstLimit;
		htmlSecondConditional="x<span class='reservedWord'> < </span>"+secondLimit;
		break;
	case 7: //1:x<first, 2: first<=x<=second, 3: x>second
		firstConditional="x<"+firstLimit;
		secondConditional="x<="+secondLimit;
		htmlFirstConditional="x<span class='reservedWord'> < </span>"+firstLimit;
        htmlSecondConditional="x<span class='reservedWord'> <= </span>"+secondLimit;
		break;
	case 8: //1:x<=first, 2: first<x<=second, 3: x>second
		firstConditional="x<="+firstLimit;
		secondConditional="x<="+secondLimit;
		htmlFirstConditional="x<span class='reservedWord'> <= </span>"+firstLimit;
        htmlSecondConditional="x<span class='reservedWord'> <= </span>"+secondLimit;
		break;
	case 9: //1:x>first, 2: x<=first, 3: κανένα
		firstConditional="x>"+firstLimit;
		secondConditional="x<"+secondLimit;
		htmlFirstConditional="x<span class='reservedWord'> > </span>"+firstLimit;
        htmlSecondConditional="x<span class='reservedWord'> < </span>"+secondLimit;
		break;
	case 10: //1:x>=first, 2: x<first, 3: κανένα
		firstConditional="x>="+firstLimit;
		secondConditional="x<"+secondLimit;
		htmlFirstConditional="x<span class='reservedWord'> >= </span>"+firstLimit;
        htmlSecondConditional="x<span class='reservedWord'> < </span>"+secondLimit;
		break;
	case 11: //1:x>first, 2: x<=first, 3: κανένα
		firstConditional="x>"+firstLimit;
		secondConditional="x<="+secondLimit;
		htmlFirstConditional="x<span class='reservedWord'> > </span>"+firstLimit;
        htmlSecondConditional="x<span class='reservedWord'> <= </span>"+secondLimit;
		break;
	case 12: //1:x>=first, 2: x<first, 3: κανένα
		firstConditional="x>="+firstLimit;
		secondConditional="x<="+secondLimit;
		htmlFirstConditional="x<span class='reservedWord'> >= </span>"+firstLimit;
        htmlSecondConditional="x<span class='reservedWord'> <= </span>"+secondLimit;
		break;
	case 13: //1:x<first, 2: x>second, 3: first<=x<=second
		firstConditional="x<"+firstLimit;
		secondConditional="x>"+secondLimit;
		htmlFirstConditional="x<span class='reservedWord'> < </span>"+firstLimit;
        htmlSecondConditional="x<span class='reservedWord'> > </span>"+secondLimit;
		break;
	case 14: //1:x<=first, 2: x>second, 3: first<x<=second
		firstConditional="x<="+firstLimit;
		secondConditional="x>"+secondLimit;
		htmlFirstConditional="x<span class='reservedWord'> <= </span>"+firstLimit;
        htmlSecondConditional="x<span class='reservedWord'> > </span>"+secondLimit;
		break;
	case 15: //1:x<first, 2: x>=second, 3: first<=x<second
		firstConditional="x<"+firstLimit;
		secondConditional="x>="+secondLimit;
		htmlFirstConditional="x<span class='reservedWord'> < </span>"+firstLimit;
        htmlSecondConditional="x<span class='reservedWord'> >= </span>"+secondLimit;
		break;
	case 16: //1:x<=first, 2: x>=second, 3: first<x<second
		firstConditional="x<="+firstLimit;
		secondConditional="x>="+secondLimit;
		htmlFirstConditional="x<span class='reservedWord'> <= </span>"+firstLimit;
        htmlSecondConditional="x<span class='reservedWord'> >= </span>"+secondLimit;
		break;
	case 17: //1:x>=second, 2: κανένα, 3: x<second
		firstConditional="x>="+firstLimit+operatorAND+"x>="+secondLimit;
		secondConditional="x>="+secondLimit;
		htmlFirstConditional="x<span class='reservedWord'> >= </span>"+firstLimit+htmlOperatorAND+"x<span class='reservedWord'> >= </span>"+secondLimit;
        htmlSecondConditional="x<span class='reservedWord'> >= </span>"+secondLimit;
		break;
	case 18: //1:x>=second, 2: first<=x<second, 3: x<first
		firstConditional="x>="+firstLimit+operatorAND+"x>="+secondLimit;
		secondConditional="x>="+firstLimit;
		htmlFirstConditional="x<span class='reservedWord'> >= </span>"+firstLimit+htmlOperatorAND+"x<span class='reservedWord'> >= </span>"+secondLimit;
        htmlSecondConditional="x<span class='reservedWord'> >= </span>"+firstLimit;
		break;
	case 19: //1:x>=second, 2: x<second, 3: κανένα
		firstConditional="x>="+firstLimit+operatorAND+"x>="+secondLimit;
		secondConditional="x<"+secondLimit;
		htmlFirstConditional="x<span class='reservedWord'> >= </span>"+firstLimit+htmlOperatorAND+"x<span class='reservedWord'> >= </span>"+secondLimit;
        htmlSecondConditional="x<span class='reservedWord'> < </span>"+secondLimit;
		break;
	case 20: //1:x>=second, 2: first<=x<second, 3: x<first
		firstConditional="x>="+firstLimit+operatorAND+"x>="+secondLimit;
		secondConditional="x>="+firstLimit;
		htmlFirstConditional="x<span class='reservedWord'> >= </span>"+firstLimit+htmlOperatorAND+"x<span class='reservedWord'> >= </span>"+secondLimit;
        htmlSecondConditional="x<span class='reservedWord'> >= </span>"+firstLimit;
		break;
	case 21: //1:first<=x<second, 2: x>=second, 3: x<first
		firstConditional="x>="+firstLimit+operatorAND+"x<"+secondLimit;
		secondConditional="x>="+firstLimit;
		htmlFirstConditional="x<span class='reservedWord'> >= </span>"+firstLimit+htmlOperatorAND+"x<span class='reservedWord'> < </span>"+secondLimit;
        htmlSecondConditional="x<span class='reservedWord'> >= </span>"+firstLimit;
		break;
	case 22: //1:first<=x<second, 2: x>=second, 3: x<first
		firstConditional="x>="+firstLimit+operatorAND+"x<"+secondLimit;
		secondConditional="x>="+secondLimit;
		htmlFirstConditional="x<span class='reservedWord'> >= </span>"+firstLimit+htmlOperatorAND+"x<span class='reservedWord'> < </span>"+secondLimit;
        htmlSecondConditional="x<span class='reservedWord'> >= </span>"+secondLimit;
		break;
	case 23: //1:κανένα, 2: x>=first, 3: x<first
		firstConditional="x>="+secondLimit+operatorAND+"x<"+firstLimit;
		secondConditional="x>="+firstLimit;
		htmlFirstConditional="x<span class='reservedWord'> >= </span>"+secondLimit+htmlOperatorAND+"x<span class='reservedWord'> < </span>"+firstLimit;
        htmlSecondConditional="x<span class='reservedWord'> >= </span>"+firstLimit;
		break;
	case 24: //1:κανένα, 2: x<=second, 3: x>second
		firstConditional="x>="+secondLimit+operatorAND+"x<"+firstLimit;
		secondConditional="x<="+secondLimit;
		htmlFirstConditional="x<span class='reservedWord'> >= </span>"+secondLimit+htmlOperatorAND+"x<span class='reservedWord'> < </span>"+firstLimit;
        htmlSecondConditional="x<span class='reservedWord'> <= </span>"+secondLimit;
		break;
    case 25: //1:first<x<second, 2: x>=second, 3: x<=first
        firstConditional="x>"+firstLimit+operatorAND+"x<"+secondLimit;
        secondConditional="x>="+secondLimit;
        htmlFirstConditional="x<span class='reservedWord'> > </span>"+firstLimit+htmlOperatorAND+"x<span class='reservedWord'> < </span>"+secondLimit;
        htmlSecondConditional="x<span class='reservedWord'> >= </span>"+secondLimit;
        break;
    case 26: //1:first<x<second, 2: x<=first, 3: x>=second
        firstConditional="x>"+firstLimit+operatorAND+"x<"+secondLimit;
        secondConditional="x<="+firstLimit;
        htmlFirstConditional="x<span class='reservedWord'> > </span>"+firstLimit+htmlOperatorAND+"x<span class='reservedWord'> < </span>"+secondLimit;
        htmlSecondConditional="x<span class='reservedWord'> <= </span>"+firstLimit;
        break;
	case 27: //1:όλα, 2: κανένα, 3: κανένα
		firstConditional="x>="+firstLimit+operatorOR+"x<"+secondLimit;
		secondConditional="x<="+secondLimit;
		htmlFirstConditional="x<span class='reservedWord'> >= </span>"+firstLimit+htmlOperatorOR+"x<span class='reservedWord'> < </span>"+secondLimit;
        htmlSecondConditional="x<span class='reservedWord'> <= </span>"+secondLimit;
		break;
	case 28: //1:x<first or x>second, 2: κανένα, 3: first<=x<=second
		firstConditional="x<"+firstLimit+operatorOR+"x>"+secondLimit;
		secondConditional="x >"+secondLimit;
		htmlFirstConditional="x<span class='reservedWord'> < </span>"+firstLimit+htmlOperatorOR+"x<span class='reservedWord'> > </span>"+secondLimit;
        htmlSecondConditional="x<span class='reservedWord'>  > </span>"+secondLimit;
		break;
    case 29: //1:x<first or x>second, 2: x=second, 3: first<=x<second
        firstConditional="x<"+firstLimit+operatorOR+"x>"+secondLimit;
        secondConditional="x>="+secondLimit;
        htmlFirstConditional="x<span class='reservedWord'> < </span>"+firstLimit+htmlOperatorOR+"x<span class='reservedWord'> > </span>"+secondLimit;
        htmlSecondConditional="x<span class='reservedWord'> >= </span>"+secondLimit;
        break;
	case 30: //1:x<first or x>second, 2: first<x<=second, 3: x=first
		firstConditional="x<"+firstLimit+operatorOR+"x>"+secondLimit;
		secondConditional="x>"+firstLimit;
		htmlFirstConditional="x<span class='reservedWord'> < </span>"+firstLimit+htmlOperatorOR+"x<span class='reservedWord'> > </span>"+secondLimit;
        htmlSecondConditional="x<span class='reservedWord'> > </span>"+firstLimit;
		break;
    case 31: //1:x<first or x>second, 2: first<=x<second, 3: x=second
        firstConditional="x<"+firstLimit+operatorOR+"x>"+secondLimit;
        secondConditional="x<"+secondLimit;
        htmlFirstConditional="x<span class='reservedWord'> < </span>"+firstLimit+htmlOperatorOR+"x<span class='reservedWord'> > </span>"+secondLimit;
        htmlSecondConditional="x<span class='reservedWord'> < </span>"+secondLimit;
        break;
	case 32: //1:x>second, 2: x<first, 3: first<=x<=second
		firstConditional="x>"+secondLimit;
		secondConditional="x<"+firstLimit;
		htmlFirstConditional="x<span class='reservedWord'> > </span>"+secondLimit;
		htmlSecondConditional="x<span class='reservedWord'> < </span>"+firstLimit;
		break;
    case 33: //1:x>=second, 2: x<first, 3: first<=x<second
        firstConditional="x>="+secondLimit;
        secondConditional="x<"+firstLimit;
        htmlFirstConditional="x<span class='reservedWord'> >= </span>"+secondLimit;
        htmlSecondConditional="x<span class='reservedWord'> < </span>"+firstLimit;
        break;
    case 34: //1:x>second, 2: x<=first, 3: first<x<=second
        firstConditional="x>"+secondLimit;
        secondConditional="x<="+firstLimit;
        htmlFirstConditional="x<span class='reservedWord'> > </span>"+secondLimit;
        htmlSecondConditional="x<span class='reservedWord'> <= </span>"+firstLimit;
        break;
    case 35: //1:x>=second, 2: x<=first, 3: first<x<second
        firstConditional="x>="+secondLimit;
        secondConditional="x<="+firstLimit;
        htmlFirstConditional="x<span class='reservedWord'> >= </span>"+secondLimit;
        htmlSecondConditional="x<span class='reservedWord'> <= </span>"+firstLimit;
        break;
    case 36: //1:x<second, 2: x>=second, 3: κανένα
        firstConditional="x<"+secondLimit;
        secondConditional="x>"+firstLimit;
        htmlFirstConditional="x<span class='reservedWord'> < </span>"+secondLimit;
        htmlSecondConditional="x<span class='reservedWord'> > </span>"+firstLimit;
        break;
    case 37: //1:κανένα, 2: όλα, 3: κανένα
        firstConditional="x<"+firstLimit+operatorAND+"x>"+secondLimit;
        secondConditional="x>"+firstLimit+operatorAND+"x<"+secondLimit;
        htmlFirstConditional="x<span class='reservedWord'> < </span>"+firstLimit+htmlOperatorAND+"x<span class='reservedWord'> > </span>"+secondLimit;
        htmlSecondConditional="x<span class='reservedWord'> > </span>"+firstLimit+htmlOperatorAND+"x<span class='reservedWord'> < </span>"+secondLimit;
        break;
    case 38: //1:first<=x<=second, 2: x>second, 3: x<first
        firstConditional=operatorNOT+"(x<"+firstLimit+operatorOR+"x>"+secondLimit+")";
        secondConditional="x>="+secondLimit;
        htmlFirstConditional=htmlOperatorNOT+"(x<span class='reservedWord'> < </span>"+firstLimit+htmlOperatorOR+"x<span class='reservedWord'> > </span>"+secondLimit+")";
        htmlSecondConditional="x<span class='reservedWord'> >= </span>"+secondLimit;
        break;
    case 39: //1:κανένα, 2: κανένα, 3: κάθε x
        firstConditional=operatorNOT+"(x>"+firstLimit+operatorOR+"x<"+secondLimit+")";
        secondConditional="x<"+firstLimit+operatorAND+"x>"+secondLimit;
        htmlFirstConditional=htmlOperatorNOT+"(x<span class='reservedWord'> > </span>"+firstLimit+htmlOperatorOR+"x<span class='reservedWord'> < </span>"+secondLimit+")";
        htmlSecondConditional="x<span class='reservedWord'> < </span>"+firstLimit+htmlOperatorAND+"x<span class='reservedWord'> > </span>"+secondLimit;
        break;
    case 40: //1:x<second, 2: x>second, 3: x=second
        firstConditional=operatorNOT+"(x>="+firstLimit+operatorAND+"x>="+secondLimit+")";
        secondConditional="x>"+secondLimit;
        htmlFirstConditional=htmlOperatorNOT+"(x<span class='reservedWord'> >= </span>"+firstLimit+htmlOperatorAND+"x<span class='reservedWord'> >= </span>"+secondLimit+")";
        htmlSecondConditional="x<span class='reservedWord'> > </span>"+secondLimit;
        break;
	}
}

function checkEntry(entryToCheck,correction,limitToCheck){
    var result=true;
    var userEntry="";
    if($("#"+entryToCheck).length){
        if(correction===""){
            userEntry=$("#"+entryToCheck).attr("data-info");
        }
        else{
            userEntry=stringExpressionValue($("#"+entryToCheck).text(),varNames,varValues,[],[],!roundResult);
        }
        if(userEntry=="error"){
            result=false;
        }
        else{
            if(correction===""){
                result=userEntry==limitToCheck;
            }
            else{
                result=parseInt(userEntry)+correction==limitToCheck;
            }
        }
    }
    else{
        result=false;
    }
    return result;
}

function checkSolution(){
    var correct=true;
    switch(problemVariation){
        case 1: //1:x>first, 2: κανένα, 3: x<=first
        case 3:
            correct=correct && checkEntry("entry1_1",-1,firstLimit);
            correct=correct && !checkEntry("entry1_2"); //δεν πρέπει να υπάρχει
            correct=correct && checkEntry("entry2_1","","κανένα x");
            correct=correct && !checkEntry("entry2_2"); //δεν πρέπει να υπάρχει
            correct=correct && !checkEntry("entry3_1"); //δεν πρέπει να υπάρχει
            correct=correct && checkEntry("entry3_2",0,firstLimit);
            break;
        case 2: //1:x>=first, 2: κανένα, 3: x<first
        case 4:
            correct=correct && checkEntry("entry1_1",0,firstLimit);
            correct=correct && !checkEntry("entry1_2"); //δεν πρέπει να υπάρχει
            correct=correct && checkEntry("entry2_1","","κανένα x");
            correct=correct && !checkEntry("entry2_2"); //δεν πρέπει να υπάρχει
            correct=correct && !checkEntry("entry3_1"); //δεν πρέπει να υπάρχει
            correct=correct && checkEntry("entry3_2",1,firstLimit);
            break;
        case 5: //1:x<first, 2: first<=x<second, 3: x>=second
            correct=correct && !checkEntry("entry1_1"); //δεν πρέπει να υπάρχει
            correct=correct && checkEntry("entry1_2",1,firstLimit);
            correct=correct && checkEntry("entry2_1",0,firstLimit);
            correct=correct && checkEntry("entry2_2",1,secondLimit);
            correct=correct && checkEntry("entry3_1",0,secondLimit);
            correct=correct && !checkEntry("entry3_2"); //δεν πρέπει να υπάρχει
            break;
        case 6: //1:x<=first, 2: first<x<second, 3: x>=second
            correct=correct && !checkEntry("entry1_1"); //δεν πρέπει να υπάρχει
            correct=correct && checkEntry("entry1_2",0,firstLimit);
            correct=correct && checkEntry("entry2_1",-1,firstLimit);
            correct=correct && checkEntry("entry2_2",1,secondLimit);
            correct=correct && checkEntry("entry3_1",0,secondLimit);
            correct=correct && !checkEntry("entry3_2"); //δεν πρέπει να υπάρχει
            break;
        case 7: //1:x<first, 2: first<=x<=second, 3: x>second
            correct=correct && !checkEntry("entry1_1"); //δεν πρέπει να υπάρχει
            correct=correct && checkEntry("entry1_2",1,firstLimit);
            correct=correct && checkEntry("entry2_1",0,firstLimit);
            correct=correct && checkEntry("entry2_2",0,secondLimit);
            correct=correct && checkEntry("entry3_1",-1,secondLimit);
            correct=correct && !checkEntry("entry3_2"); //δεν πρέπει να υπάρχει
            break;
        case 8: //1:x<=first, 2: first<x<=second, 3: x>second
            correct=correct && !checkEntry("entry1_1"); //δεν πρέπει να υπάρχει
            correct=correct && checkEntry("entry1_2",0,firstLimit);
            correct=correct && checkEntry("entry2_1",-1,firstLimit);
            correct=correct && checkEntry("entry2_2",0,secondLimit);
            correct=correct && checkEntry("entry3_1",-1,secondLimit);
            correct=correct && !checkEntry("entry3_2"); //δεν πρέπει να υπάρχει
            break;
        case 9: //1:x>first, 2: x<=first, 3: κανένα
        case 11:
            correct=correct && checkEntry("entry1_1",-1,firstLimit);
            correct=correct && !checkEntry("entry1_2"); //δεν πρέπει να υπάρχει
            correct=correct && !checkEntry("entry2_1"); //δεν πρέπει να υπάρχει
            correct=correct && checkEntry("entry2_2",0,firstLimit);
            correct=correct && checkEntry("entry3_1","","κανένα x");
            correct=correct && !checkEntry("entry3_2"); //δεν πρέπει να υπάρχει
            break;
        case 10: //1:x>=first, 2: x<first, 3: κανένα
        case 12:
            correct=correct && checkEntry("entry1_1",0,firstLimit);
            correct=correct && !checkEntry("entry1_2"); //δεν πρέπει να υπάρχει
            correct=correct && !checkEntry("entry2_1"); //δεν πρέπει να υπάρχει
            correct=correct && checkEntry("entry2_2",1,firstLimit);
            correct=correct && checkEntry("entry3_1","","κανένα x");
            correct=correct && !checkEntry("entry3_2"); //δεν πρέπει να υπάρχει
            break;
        case 13: //1:x<first, 2: x>second, 3: first<=x<=second
            correct=correct && !checkEntry("entry1_1"); //δεν πρέπει να υπάρχει
            correct=correct && checkEntry("entry1_2",1,firstLimit);
            correct=correct && checkEntry("entry2_1",-1,secondLimit);
            correct=correct && !checkEntry("entry2_2"); //δεν πρέπει να υπάρχει
            correct=correct && checkEntry("entry3_1",0,firstLimit);
            correct=correct && checkEntry("entry3_2",0,secondLimit);
            break;
        case 14: //1:x<=first, 2: x>second, 3: first<x<=second
            correct=correct && !checkEntry("entry1_1"); //δεν πρέπει να υπάρχει
            correct=correct && checkEntry("entry1_2",0,firstLimit);
            correct=correct && checkEntry("entry2_1",-1,secondLimit);
            correct=correct && !checkEntry("entry2_2"); //δεν πρέπει να υπάρχει
            correct=correct && checkEntry("entry3_1",-1,firstLimit);
            correct=correct && checkEntry("entry3_2",0,secondLimit);
            break;
        case 15: //1:x<first, 2: x>=second, 3: first<=x<second
            correct=correct && !checkEntry("entry1_1"); //δεν πρέπει να υπάρχει
            correct=correct && checkEntry("entry1_2",1,firstLimit);
            correct=correct && checkEntry("entry2_1",0,secondLimit);
            correct=correct && !checkEntry("entry2_2"); //δεν πρέπει να υπάρχει
            correct=correct && checkEntry("entry3_1",0,firstLimit);
            correct=correct && checkEntry("entry3_2",1,secondLimit);
            break;
        case 16: //1:x<=first, 2: x>=second, 3: first<x<second
            correct=correct && !checkEntry("entry1_1"); //δεν πρέπει να υπάρχει
            correct=correct && checkEntry("entry1_2",0,firstLimit);
            correct=correct && checkEntry("entry2_1",0,secondLimit);
            correct=correct && !checkEntry("entry2_2"); //δεν πρέπει να υπάρχει
            correct=correct && checkEntry("entry3_1",-1,firstLimit);
            correct=correct && checkEntry("entry3_2",1,secondLimit);
            break;
        case 17: //1:x>=second, 2: κανένα, 3: x<second
            correct=correct && checkEntry("entry1_1",0,secondLimit);
            correct=correct && !checkEntry("entry1_2"); //δεν πρέπει να υπάρχει
            correct=correct && checkEntry("entry2_1","","κανένα x");
            correct=correct && !checkEntry("entry2_2"); //δεν πρέπει να υπάρχει
            correct=correct && !checkEntry("entry3_1"); //δεν πρέπει να υπάρχει
            correct=correct && checkEntry("entry3_2",1,secondLimit);
            break;
        case 18: //1:x>=second, 2: first<=x<second, 3: x<first
        case 20:
            correct=correct && checkEntry("entry1_1",0,secondLimit);
            correct=correct && !checkEntry("entry1_2"); //δεν πρέπει να υπάρχει
            correct=correct && checkEntry("entry2_1",0,firstLimit);
            correct=correct && checkEntry("entry2_2",1,secondLimit);
            correct=correct && !checkEntry("entry3_1"); //δεν πρέπει να υπάρχει
            correct=correct && checkEntry("entry3_2",1,firstLimit);
            break;
        case 19: //1:x>=second, 2: x<second, 3: κανένα
            correct=correct && checkEntry("entry1_1",0,secondLimit);
            correct=correct && !checkEntry("entry1_2"); //δεν πρέπει να υπάρχει
            correct=correct && !checkEntry("entry2_1"); //δεν πρέπει να υπάρχει
            correct=correct && checkEntry("entry2_2",1,secondLimit);
            correct=correct && checkEntry("entry3_1","","κανένα x");
            correct=correct && !checkEntry("entry3_2"); //δεν πρέπει να υπάρχει
            break;
        case 21: //1:first<=x<second, 2: x>=second, 3: x<first
        case 22:
            correct=correct && checkEntry("entry1_1",0,firstLimit);
            correct=correct && checkEntry("entry1_2",1,secondLimit);
            correct=correct && checkEntry("entry2_1",0,secondLimit);
            correct=correct && !checkEntry("entry2_2"); //δεν πρέπει να υπάρχει
            correct=correct && !checkEntry("entry3_1"); //δεν πρέπει να υπάρχει
            correct=correct && checkEntry("entry3_2",1,firstLimit);
            break;
        case 23: //1:κανένα, 2: x>=first, 3: x<first
            correct=correct && checkEntry("entry1_1","","κανένα x");
            correct=correct && !checkEntry("entry1_2"); //δεν πρέπει να υπάρχει
            correct=correct && checkEntry("entry2_1",0,firstLimit);
            correct=correct && !checkEntry("entry2_2"); //δεν πρέπει να υπάρχει
            correct=correct && !checkEntry("entry3_1"); //δεν πρέπει να υπάρχει
            correct=correct && checkEntry("entry3_2",1,firstLimit);
            break;
        case 24: //1:κανένα, 2: x<=second, 3: x>second
            correct=correct && checkEntry("entry1_1","","κανένα x");
            correct=correct && !checkEntry("entry1_2"); //δεν πρέπει να υπάρχει
            correct=correct && !checkEntry("entry2_1"); //δεν πρέπει να υπάρχει
            correct=correct && checkEntry("entry2_2",0,secondLimit);
            correct=correct && checkEntry("entry3_1",-1,secondLimit);
            correct=correct && !checkEntry("entry3_2"); //δεν πρέπει να υπάρχει
            break;
        case 25: //1:first<x<second, 2: x>=second, 3: x<=first
            correct=correct && checkEntry("entry1_1",-1,firstLimit);
            correct=correct && checkEntry("entry1_2",1,secondLimit);
            correct=correct && checkEntry("entry2_1",0,secondLimit);
            correct=correct && !checkEntry("entry2_2"); //δεν πρέπει να υπάρχει
            correct=correct && !checkEntry("entry3_1"); //δεν πρέπει να υπάρχει
            correct=correct && checkEntry("entry3_2",0,firstLimit);
            break;
        case 26: //1:first<x<second, 2: x<=first, 3: x>=second
            correct=correct && checkEntry("entry1_1",-1,firstLimit);
            correct=correct && checkEntry("entry1_2",1,secondLimit);
            correct=correct && !checkEntry("entry2_1"); //δεν πρέπει να υπάρχει
            correct=correct && checkEntry("entry2_2",0,firstLimit);
            correct=correct && checkEntry("entry3_1",0,secondLimit);
            correct=correct && !checkEntry("entry3_2"); //δεν πρέπει να υπάρχει
            break;
        case 27: //1:όλα, 2: κανένα, 3: κανένα
            correct=correct && checkEntry("entry1_1","","κάθε x");
            correct=correct && !checkEntry("entry1_2"); //δεν πρέπει να υπάρχει
            correct=correct && checkEntry("entry2_1","","κανένα x");
            correct=correct && !checkEntry("entry2_2"); //δεν πρέπει να υπάρχει
            correct=correct && checkEntry("entry3_1","","κανένα x");
            correct=correct && !checkEntry("entry3_2"); //δεν πρέπει να υπάρχει
            break;
        case 28: //1:x<first or x>second, 2: κανένα, 3: first<=x<=second
            correct=correct && !checkEntry("entry1_1"); //δεν πρέπει να υπάρχει
            correct=correct && checkEntry("entry1_2",1,firstLimit);
            correct=correct && checkEntry("entry1b_1",-1,secondLimit);
            correct=correct && !checkEntry("entry1b_2"); //δεν πρέπει να υπάρχει
            correct=correct && checkEntry("entry2_1","","κανένα x");
            correct=correct && !checkEntry("entry2_2"); //δεν πρέπει να υπάρχει
            correct=correct && checkEntry("entry3_1",0,firstLimit);
            correct=correct && checkEntry("entry3_2",0,secondLimit);
            break;
        case 29: //1:x<first or x>second, 2: x=second, 3: first<=x<second
            correct=correct && !checkEntry("entry1_1"); //δεν πρέπει να υπάρχει
            correct=correct && checkEntry("entry1_2",1,firstLimit);
            correct=correct && checkEntry("entry1b_1",-1,secondLimit);
            correct=correct && !checkEntry("entry1b_2"); //δεν πρέπει να υπάρχει
            correct=correct && checkEntry("entry2_1_EQ",0,secondLimit);
            correct=correct && !checkEntry("entry2_2"); //δεν πρέπει να υπάρχει
            correct=correct && checkEntry("entry3_1",0,firstLimit);
            correct=correct && checkEntry("entry3_2",1,secondLimit);
            break;
        case 30:  //1:x<first or x>second, 2: first<x<=second, 3: x=first
            correct=correct && !checkEntry("entry1_1"); //δεν πρέπει να υπάρχει
            correct=correct && checkEntry("entry1_2",1,firstLimit);
            correct=correct && checkEntry("entry1b_1",-1,secondLimit);
            correct=correct && !checkEntry("entry1b_2"); //δεν πρέπει να υπάρχει
            correct=correct && checkEntry("entry2_1",-1,firstLimit);
            correct=correct && checkEntry("entry2_2",0,secondLimit);
            correct=correct && checkEntry("entry3_1_EQ",0,firstLimit);
            correct=correct && !checkEntry("entry3_2"); //δεν πρέπει να υπάρχει
            break;
        case 31: //1:x<first or x>second, 2: first<=x<second, 3: x=second
            correct=correct && !checkEntry("entry1_1"); //δεν πρέπει να υπάρχει
            correct=correct && checkEntry("entry1_2",1,firstLimit);
            correct=correct && checkEntry("entry1b_1",-1,secondLimit);
            correct=correct && !checkEntry("entry1b_2"); //δεν πρέπει να υπάρχει
            correct=correct && checkEntry("entry2_1",0,firstLimit);
            correct=correct && checkEntry("entry2_2",1,secondLimit);
            correct=correct && checkEntry("entry3_1_EQ",0,secondLimit);
            correct=correct && !checkEntry("entry3_2"); //δεν πρέπει να υπάρχει
            break;
        case 32: //1:x>second, 2: x<first, 3: first<=x<=second
            correct=correct && checkEntry("entry1_1",-1,secondLimit);
            correct=correct && !checkEntry("entry1_2"); //δεν πρέπει να υπάρχει
            correct=correct && !checkEntry("entry2_1"); //δεν πρέπει να υπάρχει
            correct=correct && checkEntry("entry2_2",1,firstLimit);
            correct=correct && checkEntry("entry3_1",0,firstLimit);
            correct=correct && checkEntry("entry3_2",0,secondLimit);
            break;
        case 33: //1:x>=second, 2: x<first, 3: first<=x<second
            correct=correct && checkEntry("entry1_1",0,secondLimit);
            correct=correct && !checkEntry("entry1_2"); //δεν πρέπει να υπάρχει
            correct=correct && !checkEntry("entry2_1"); //δεν πρέπει να υπάρχει
            correct=correct && checkEntry("entry2_2",1,firstLimit);
            correct=correct && checkEntry("entry3_1",0,firstLimit);
            correct=correct && checkEntry("entry3_2",1,secondLimit);
            break;
        case 34: //1:x>second, 2: x<=first, 3: first<x<=second
            correct=correct && checkEntry("entry1_1",-1,secondLimit);
            correct=correct && !checkEntry("entry1_2"); //δεν πρέπει να υπάρχει
            correct=correct && !checkEntry("entry2_1"); //δεν πρέπει να υπάρχει
            correct=correct && checkEntry("entry2_2",0,firstLimit);
            correct=correct && checkEntry("entry3_1",-1,firstLimit);
            correct=correct && checkEntry("entry3_2",0,secondLimit);
            break;
        case 35: //1:x>=second, 2: x<=first, 3: first<x<second
            correct=correct && checkEntry("entry1_1",0,secondLimit);
            correct=correct && !checkEntry("entry1_2"); //δεν πρέπει να υπάρχει
            correct=correct && !checkEntry("entry2_1"); //δεν πρέπει να υπάρχει
            correct=correct && checkEntry("entry2_2",0,firstLimit);
            correct=correct && checkEntry("entry3_1",-1,firstLimit);
            correct=correct && checkEntry("entry3_2",1,secondLimit);
            break;
        case 36: //1:x<second, 2: x>=second, 3: κανένα
            correct=correct && !checkEntry("entry1_1"); //δεν πρέπει να υπάρχει
            correct=correct && checkEntry("entry1_2",1,secondLimit);
            correct=correct && checkEntry("entry2_1",0,secondLimit);
            correct=correct && !checkEntry("entry2_2"); //δεν πρέπει να υπάρχει
            correct=correct && checkEntry("entry3_1","","κανένα x");
            correct=correct && !checkEntry("entry3_2"); //δεν πρέπει να υπάρχει
            break;
        case 37: //1:κανένα, 2: όλα, 3: κανένα
            correct=correct && checkEntry("entry1_1","","κανένα x");
            correct=correct && !checkEntry("entry1_2"); //δεν πρέπει να υπάρχει
            correct=correct && checkEntry("entry2_1","","κάθε x");
            correct=correct && !checkEntry("entry2_2"); //δεν πρέπει να υπάρχει
            correct=correct && checkEntry("entry3_1","","κανένα x");
            correct=correct && !checkEntry("entry3_2"); //δεν πρέπει να υπάρχει
            break;
        case 38: //1:first<=x<=second, 2: x>second, 3: x<first
            correct=correct && checkEntry("entry1_1",0,firstLimit);
            correct=correct && checkEntry("entry1_2",0,secondLimit);
            correct=correct && checkEntry("entry2_1",-1,secondLimit);
            correct=correct && !checkEntry("entry2_2"); //δεν πρέπει να υπάρχει
            correct=correct && !checkEntry("entry3_1"); //δεν πρέπει να υπάρχει
            correct=correct && checkEntry("entry3_2",1,firstLimit);
            break;
        case 39: //1:κανένα, 2: κανένα, 3: κάθε x
            correct=correct && checkEntry("entry1_1","","κανένα x");
            correct=correct && !checkEntry("entry1_2"); //δεν πρέπει να υπάρχει
            correct=correct && checkEntry("entry2_1","","κανένα x");
            correct=correct && !checkEntry("entry2_2"); //δεν πρέπει να υπάρχει
            correct=correct && checkEntry("entry3_1","","κάθε x");
            correct=correct && !checkEntry("entry3_2"); //δεν πρέπει να υπάρχει
            break;
        case 40: //1:x<second, 2: x>second, 3: x=second
            correct=correct && !checkEntry("entry1_1"); //δεν πρέπει να υπάρχει
            correct=correct && checkEntry("entry1_2",1,secondLimit);
            correct=correct && checkEntry("entry2_1",-1,secondLimit);
            correct=correct && !checkEntry("entry2_2"); //δεν πρέπει να υπάρχει
            correct=correct && checkEntry("entry3_1_EQ",0,secondLimit);
            correct=correct && !checkEntry("entry3_2"); //δεν πρέπει να υπάρχει
            break;
    }
    errorsFound=!correct;
    promptID=promptSubmittedSolution;
    showPrompt();
    enableCodeSimulation();
}

function xGT(limit){
	return exprStart[slctdSymbols]+rightInfinityStart[slctdSymbols]+(limit+1)+rightInfinityEnd[slctdSymbols];
}

function xGTEQ(limit){
	return exprStart[slctdSymbols]+rightInfinityStart[slctdSymbols]+limit+rightInfinityEnd[slctdSymbols];
}

function xLT(limit){
	return exprStart[slctdSymbols]+leftInfinityStart[slctdSymbols]+(limit-1)+leftInfinityEnd[slctdSymbols];
}

function xLTEQ(limit){
	return exprStart[slctdSymbols]+leftInfinityStart[slctdSymbols]+limit+leftInfinityEnd[slctdSymbols];
}

function range(limit1,limit2,leftBorder,rightBorder){
	var lm1=limit1;
	var lm2=limit2;
	if(leftBorder=="open"){
		lm1++;
	}
	if(rightBorder=="open"){
		lm2--;
	}
	return exprStart[slctdSymbols]+leftLimit[slctdSymbols]+lm1+rangeMiddle[slctdSymbols]+lm2+rightLimit[slctdSymbols];
}

function xEQ(limit){
	return exprStart[slctdSymbols]+leftLimitForSingle[slctdSymbols]+limit+closingSet[slctdSymbols];
}

function showSolution(){
	var ln1="";
	var ln2="";
	var ln3="";
    switch(problemVariation){
    case 1: //1:x>first, 2: κανένα, 3: x<=first
    case 3:
    	ln1=xGT(firstLimit);
    	ln2=exprForNone[slctdSymbols];
    	ln3=xLTEQ(firstLimit);
    	break;
    case 2: //1:x>=first, 2: κανένα, 3: x<first
    case 4:
    	ln1=xGTEQ(firstLimit);
    	ln2=exprForNone[slctdSymbols];
    	ln3=xLT(firstLimit);
        break;
    case 5: //1:x<first, 2: first<=x<second, 3: x>=second
    	ln1=xLT(firstLimit);
    	ln2=range(firstLimit,secondLimit,"closed","open");
    	ln3=xGTEQ(secondLimit);
        break;
    case 6: //1:x<=first, 2: first<x<second, 3: x>=second
    	ln1=xLTEQ(firstLimit);
    	ln2=range(firstLimit,secondLimit,"open","open");
    	ln3=xGTEQ(secondLimit);
        break;
    case 7: //1:x<first, 2: first<=x<=second, 3: x>second
    	ln1=xLT(firstLimit);
    	ln2=range(firstLimit,secondLimit,"closed","closed");
    	ln3=xGT(secondLimit);
        break;
    case 8: //1:x<=first, 2: first<x<=second, 3: x>second
    	ln1=xLTEQ(firstLimit);
    	ln2=range(firstLimit,secondLimit,"open","closed");
    	ln3=xGT(secondLimit);
        break;
    case 9: //1:x>first, 2: x<=first, 3: κανένα
    case 11:
    	ln1=xGT(firstLimit);
    	ln2=xLTEQ(firstLimit);
    	ln3=exprForNone[slctdSymbols];
        break;
    case 10: //1:x>=first, 2: x<first, 3: κανένα
    case 12:
    	ln1=xGTEQ(firstLimit);
    	ln2=xLT(firstLimit);
    	ln3=exprForNone[slctdSymbols];
        break;
    case 13: //1:x<first, 2: x>second, 3: first<=x<=second
    	ln1=xLT(firstLimit);
    	ln2=xGT(secondLimit);
    	ln3=range(firstLimit,secondLimit,"closed","closed");
    	break;
    case 14: //1:x<=first, 2: x>second, 3: first<x<=second
    	ln1=xLTEQ(firstLimit);
    	ln2=xGT(secondLimit);
    	ln3=range(firstLimit,secondLimit,"open","closed");
    	break;
    case 15: //1:x<first, 2: x>=second, 3: first<=x<second
    	ln1=xLT(firstLimit);
    	ln2=xGTEQ(secondLimit);
    	ln3=range(firstLimit,secondLimit,"closed","open");
        break;
    case 16: //1:x<=first, 2: x>=second, 3: first<x<second
    	ln1=xLTEQ(firstLimit);
    	ln2=xGTEQ(secondLimit);
    	ln3=range(firstLimit,secondLimit,"open","open");
        break;
    case 17: //1:x>=second, 2: κανένα, 3: x<second
    	ln1=xGTEQ(secondLimit);
    	ln2=exprForNone[slctdSymbols];
    	ln3=xLT(secondLimit);
        break;
    case 18: //1:x>=second, 2: first<=x<second, 3: x<first
    case 20:
    	ln1=xLTEQ(secondLimit);
    	ln2=range(firstLimit,secondLimit,"closed","open");
    	ln3=xLT(firstLimit);
        break;
    case 19: //1:x>=second, 2: x<second, 3: κανένα
    	ln1=xGTEQ(secondLimit);
    	ln2=xLT(secondLimit);
    	ln3=exprForNone[slctdSymbols];
        break;
    case 21: //1:first<=x<second, 2: x>=second, 3: x<first
    case 22:
    	ln1=range(firstLimit,secondLimit,"closed","open");
    	ln2=xGTEQ(secondLimit);
    	ln3=xLT(firstLimit);
    	break;
    case 23: //1:κανένα, 2: x>=first, 3: x<first
    	ln1=exprForNone[slctdSymbols];
    	ln2=xGTEQ(firstLimit);
    	ln3=xLT(firstLimit);
        break;
    case 24: //1:κανένα, 2: x<=second, 3: x>second
    	ln1=exprForNone[slctdSymbols];
    	ln2=xLTEQ(secondLimit);
    	ln3=xGT(secondLimit);
        break;
    case 25: //1:first<x<second, 2: x>=second, 3: x<=first
    	ln1=range(firstLimit,secondLimit,"open","open");
    	ln2=xGTEQ(secondLimit);
    	ln3=xLTEQ(firstLimit);
        break;
    case 26: //1:first<x<second, 2: x<=first, 3: x>=second
    	ln1=range(firstLimit,secondLimit,"open","open");
    	ln2=xLTEQ(firstLimit);
    	ln3=xGTEQ(secondLimit);
        break;
    case 27: //1:όλα, 2: κανένα, 3: κανένα
    	ln1=exprForAll[slctdSymbols];
    	ln2=exprForNone[slctdSymbols];
    	ln3=exprForNone[slctdSymbols];
        break;
    case 28: //1:x<first or x>second, 2: κανένα, 3: first<=x<=second
    	ln1=xLT(firstLimit)+exprSetUnionSymbol[slctdSymbols]+xGT(secondLimit);
    	ln2=exprForNone[slctdSymbols];
    	ln3=range(firstLimit,secondLimit,"closed","closed");
    	break;
    case 29: //1:x<first or x>second, 2: x=second, 3: first<=x<second
    	ln1=xLT(firstLimit)+exprSetUnionSymbol[slctdSymbols]+xGT(secondLimit);
    	ln2=xEQ(secondLimit);
    	ln3=range(firstLimit,secondLimit,"closed","open");
    	break;
    case 30:  //1:x<first or x>second, 2: first<x<=second, 3: x=first
    	ln1=xLT(firstLimit)+exprSetUnionSymbol[slctdSymbols]+xGT(secondLimit);
    	ln2=range(firstLimit,secondLimit,"open","closed");
    	ln3=xEQ(firstLimit);
    	break;
    case 31: //1:x<first or x>second, 2: first<=x<second, 3: x=second
    	ln1=xLT(firstLimit)+exprSetUnionSymbol[slctdSymbols]+xGT(secondLimit);
    	ln2=range(firstLimit,secondLimit,"closed","open");
    	ln3=xEQ(secondLimit);
        break;
    case 32: //1:x>second, 2: x<first, 3: first<=x<=second
    	ln1=xGT(secondLimit);
    	ln2=xLT(firstLimit);
    	ln3=range(firstLimit,secondLimit,"closed","closed");
        break;
    case 33: //1:x>=second, 2: x<first, 3: first<=x<second
    	ln1=xGTEQ(secondLimit);
    	ln2=xLT(firstLimit);
    	ln3=range(firstLimit,secondLimit,"closed","open");
        break;
    case 34: //1:x>second, 2: x<=first, 3: first<x<=second
    	ln1=xGT(secondLimit);
    	ln2=xLTEQ(firstLimit);
    	ln3=range(firstLimit,secondLimit,"open","closed");
        break;
    case 35: //1:x>=second, 2: x<=first, 3: first<x<second
    	ln1=xGTEQ(secondLimit);
    	ln2=xLTEQ(firstLimit);
    	ln3=range(firstLimit,secondLimit,"open","open");
        break;
    case 36: //1:x<second, 2: x>=second, 3: κανένα
    	ln1=xLT(secondLimit);
    	ln2=xGTEQ(secondLimit);
    	ln3=exprForNone[slctdSymbols];
        break;
    case 37: //1:κανένα, 2: όλα, 3: κανένα
    	ln1=exprForNone[slctdSymbols];
    	ln2=exprForAll[slctdSymbols];
    	ln3=exprForNone[slctdSymbols];
        break;
    case 38: //1:first<=x<=second, 2: x>second, 3: x<first
    	ln1=range(firstLimit,secondLimit,"closed","closed");
    	ln2=xGT(secondLimit);
    	ln3=xLT(firstLimit);
        break;
    case 39: //1:κανένα, 2: κανένα, 3: κάθε x
    	ln1=exprForNone[slctdSymbols];
    	ln2=exprForNone[slctdSymbols];
    	ln3=exprForAll[slctdSymbols];
        break;
    case 40: //1:x<second, 2: x>second, 3: x=second
    	ln1=xLT(secondLimit);
    	ln2=xGT(secondLimit);
    	ln3=xEQ(secondLimit);
        break;
    }
    var msg="<code class='algorithm'><p>Το απόσπασμα εμφανίζει:</p>";
    msg+="1 "+ln1+"<br>";
    msg+="2 "+ln2+"<br>";
    msg+="3 "+ln3+"</code>";
    $("#solutionArea").html(msg);
}